<?php

namespace Modules\Pp\Http\Controllers;

use Exception;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\DB;
use Modules\Pp\Entities\OutsideFactory;
use Modules\St\Entities\Suppliers;

class OutsideFactoryController extends Controller
{
    public function loadSupplier(){
        try {
            $Suppliers =Suppliers::all();
            $Suppliers_arr = [];

            foreach ($Suppliers as $Supplier) {
                array_push($Suppliers_arr, ["img" => "", "id" => $Supplier['supplier_id'], "value" => $Supplier['supplier_name']]);
            }

            return $this->responseBody(true, "loadSupplier", "found", $Suppliers_arr);
        }
         catch (Exception $exception) {
            return $this->responseBody(false, "loadSupplier", "error", $exception->getMessage());
        }
    }
    function alldata(){
        try{
            // $machinary=new Machinary();
            // $result=$machinary->all();
            $result=DB::table('pp_outside_factory')->get();

            $responseBody = $this->responseBody(true, "suppliers all", "found", $result);



        }
        catch(\Exception $ex){
            $responseBody = $this->responseBody(false, " suppliers", "error", $ex);

        }
        return response()->json(["data" => $responseBody]);
    }
    public function saveOutSideFactory(Request $request){
        try{
            $outsideFactory=new outsideFactory();
            $outsideFactory->outside_factory_code=$request->get('outside_factory_code');
            $outsideFactory->outside_factory_name=$request->get('outside_factory_name');
            $outsideFactory->outside_factory_place=$request->get('outside_factory_place');
            $outsideFactory->outside_factory_description=$request->get('outside_factory_description');
            $outsideFactory->supplier_id=$request->get('supplier_id');
            $outsideFactory->status=true;
            $result=$outsideFactory->save();

            if($result){
                $responseBody = $this->responseBody(true, "outsideFactory", "saved", $outsideFactory);

            }
            else{
            $responseBody = $this->responseBody(false, " outsideFactory", "error", null);

            }
        }
        catch(\Exception $ex){
            $responseBody = $this->responseBody(false, " machinary", "error", $ex);

        }
        return response()->json(["data" => $responseBody]);
    }
    function update(Request $request){
        try{
            $outsideFactory=outsideFactory::where('outside_factory_id',$request->get('outside_factory_id'))
            ->update([
                'outside_factory_code'=>$request->get('outside_factory_code'),
                'outside_factory_name'=>$request->get('outside_factory_name'),
                'outside_factory_place'=>$request->get('outside_factory_place'),
                'outside_factory_description'=>$request->get('outside_factory_description'),
                'supplier_id'=>$request->get('supplier_id'),
                ]);

            if($outsideFactory){
                $responseBody = $this->responseBody(true, "outsideFactory", "updated", $request->get('outside_factory_code'));

            }
            else{
                $responseBody = $this->responseBody(false, " outsideFactory", "error",$request->get('outside_factory_code') );

            }

        }
        catch(\Exception $ex){
            $responseBody = $this->responseBody(false, " machinary", "error", $ex->getMessage());

        }
        return response()->json(["data" => $responseBody]);
    }
    function edit($id){
        try{
            $outsideFactory=DB::table('pp_outside_factory')
                                ->leftJoin('st_suppliers','pp_outside_factory.supplier_id','st_suppliers.supplier_id')
                                ->where('outside_factory_id',$id)
                                ->select('pp_outside_factory.*','st_suppliers.supplier_name')->first();

            $responseBody = $this->responseBody(true, "outsideFactory edit data", "Sucess", $outsideFactory);

        }
        catch(\Exception $ex){
            $responseBody = $this->responseBody(false, " outsideFactory edit data", "error", $ex);

        }
        return response()->json(["data" => $responseBody]);
    }
    function delete($id){
        try{
            $outsideFactory=outsideFactory::where('outside_factory_id',$id)->delete();

            $responseBody = $this->responseBody(true, "outsideFactory delete", "deleted", $outsideFactory);

        }
        catch(\Exception $ex){
            $responseBody = $this->responseBody(false, " outsideFactory delete", "error", $ex);

        }
        return response()->json(["data" => $responseBody]);
    }
    function disable(Request $request,$id){
        try{
            $outsideFactory=outsideFactory::where('outside_factory_id',$id)->Update(['status'=>$request->status]);

            $responseBody = $this->responseBody(true, "outsideFactory status", "Sucess", $request->status);

        }
        catch(\Exception $ex){
            $responseBody = $this->responseBody(false, " outsideFactory status", "error", $ex);

        }
        return response()->json(["data" => $responseBody]);
}
        //responcebody
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
